#version 330

out vec4 outputColor;

/*
uniform vec4       ambientColor;
uniform vec4       diffuseColor;   
uniform vec4       specularColor;
*/

uniform sampler2D  cloudTexture;
uniform float      dissolveFactor;

smooth in vec3 vVaryingNormal;
smooth in vec3 vVaryingLightDir;
smooth in vec2 vVaryingTexCoord;

void main(void)
{ 
    vec4 vCloudSample = texture(cloudTexture, vVaryingTexCoord);

    if(vCloudSample.r < dissolveFactor)
		discard;
   
	vec4 ambientColor = vec4(0.1f, 0.1f, 0.1f, 1.0f);
	vec4 diffuseColor = vec4(0.0f, 0.0f, 1.0f, 1.0f);
	vec4 specularColor = vec4(1.0f, 1.0f, 1.0f, 1.0f);
    
	//calculate diffuse intensity with dot product
	float diffuse = max(0.0f, dot(normalize(vVaryingNormal), normalize(vVaryingLightDir)));

    //multiply diffuse intensity by diffuse color
	outputColor = diffuse * diffuseColor;

    //add ambient light
	outputColor += ambientColor;

	//add specular highlights
	vec3 vReflection = normalize(reflect(-normalize(vVaryingLightDir), normalize(vVaryingNormal)));
	float specular = max(0.0f, dot(normalize(vVaryingNormal), vReflection));
	
	if(diffuse != 0.0f)
	{
		float spec = pow(specular, 128.0f);
		outputColor.rgb += vec3(spec, spec, spec);
	}
}