#version 330
//#extension GL_NV_tesselation_shader : enable
#extension GL_EXT_geometry_shader4 : enable

layout(std140) uniform GlobalMatrices
{
    uniform mat4 perspectiveViewMatrix;
    uniform vec2 windowDimensions;
};

layout(points) in;
layout(triangle_strip) out;
in float age[1];
out vec2 TexCoord;
out float agef;

void main(void)
{
    if(age[0] > 0) {
        agef = age[0];
        mat4 gVP = perspectiveViewMatrix;
        vec3 Pos = gl_PositionIn[0].xyz;
        vec3 toCamera = normalize(Pos);
		                               
	    vec3 up = vec3(0.0, 1.0, 0.0);
        vec3 right = cross(toCamera, up)*agef;

        Pos -= (right * 0.5*agef);
        Pos.y -= .5*agef;
        gl_Position = gVP * vec4(Pos, 1.0);
        TexCoord = vec2(0.0, 0.0);
        EmitVertex();
        Pos.y += agef;
        gl_Position = gVP * vec4(Pos, 1.0);
        TexCoord = vec2(0.0, 1.0);
        EmitVertex();
        Pos.y -= agef;
        Pos += right;
        TexCoord = vec2(1.0, 0.0);
        gl_Position = gVP * vec4(Pos, 1.0);
        EmitVertex();
        Pos.y += agef;
        gl_Position = gVP * vec4(Pos, 1.0);
        TexCoord = vec2(1.0, 1.0);
        EmitVertex();
        EndPrimitive();
    }

}